diff --git a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageDummy.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageDummy.java
index 0f667e959..5085c760a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageDummy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageDummy.java
@@ -2,12 +2,9 @@ package net.minecraft.core.world.save;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.world.chunk.IChunkLoader;
+import net.minecraft.core.world.chunk.ChunkLoader;
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.save.DimensionData;
-import net.minecraft.core.world.save.LevelData;
-import net.minecraft.core.world.save.LevelStorage;
-import net.minecraft.core.world.save.PlayerIO;
+import net.minecraft.core.world.saveddata.SavedDataStorage;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -17,31 +14,33 @@ import java.util.UUID;
 
 public class LevelStorageDummy implements LevelStorage
 {
+	private final @NotNull SavedDataStorage savedDataStorage;
+
 	public LevelStorageDummy()
 	{
-		
+		this.savedDataStorage = new SavedDataStorage(this);
 	}
 
 	@Override
-    public LevelData getLevelData()
+    public @Nullable LevelData getLevelData()
 	{
 		return null;
 	}
 
 	@Override
-	public CompoundTag getLevelDataRaw()
+	public @Nullable CompoundTag getLevelDataRaw()
 	{
 		return null;
 	}
 
 	@Override
-	public DimensionData getDimensionData(int dimensionId)
+	public @Nullable DimensionData getDimensionData(final @NotNull Dimension dimension)
 	{
 		return null;
 	}
 
 	@Override
-	public CompoundTag getDimensionDataRaw(int dimensionId)
+	public @Nullable CompoundTag getDimensionDataRaw(final @NotNull Dimension dimension)
 	{
 		return null;
 	}
@@ -53,7 +52,7 @@ public class LevelStorageDummy implements LevelStorage
 	}
 
 	@Override
-	public IChunkLoader getChunkLoader(Dimension dimension)
+	public @Nullable ChunkLoader getChunkLoader(@NotNull Dimension dimension)
 	{
 		return null;
 	}
@@ -65,31 +64,31 @@ public class LevelStorageDummy implements LevelStorage
 	}
 
 	@Override
-	public void saveLevelData(LevelData levelData)
+	public void saveLevelData(@NotNull LevelData levelData)
 	{
 		
 	}
 
 	@Override
-	public void saveLevelDataRaw(CompoundTag levelDataTag)
+	public void saveLevelDataRaw(@NotNull CompoundTag levelDataTag)
 	{
 
 	}
 
 	@Override
-	public void saveDimensionData(int dimensionId, DimensionData dimensionData)
+	public void saveDimensionData(int dimensionId, @NotNull DimensionData dimensionData)
 	{
 
 	}
 
 	@Override
-	public void saveDimensionDataRaw(int dimensionId, CompoundTag dimensionDataTag)
+	public void saveDimensionDataRaw(int dimensionId, @NotNull CompoundTag dimensionDataTag)
 	{
 
 	}
 
 	@Override
-	public File getDataFile(String fileName)
+	public File getDataFile(@NotNull String fileName)
 	{
 		return null;
 	}
@@ -114,4 +113,9 @@ public class LevelStorageDummy implements LevelStorage
 	public void load(@NotNull Player player) {
 
 	}
+
+	@Override
+	public @NotNull SavedDataStorage getSavedDataStorage() {
+		return this.savedDataStorage;
+	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageServer.java b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageServer.java
index c57d949e8..682bcd474 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageServer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/LevelStorageServer.java
@@ -3,10 +3,11 @@ package net.minecraft.core.world.save;
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.tags.CompoundTag;
-import net.minecraft.core.world.chunk.IChunkLoader;
+import net.minecraft.core.world.chunk.ChunkLoader;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.chunk.ChunkLoaderRegion;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 
@@ -26,7 +27,7 @@ public class LevelStorageServer
     }
     
     @Override
-    public IChunkLoader getChunkLoader(Dimension dimension)
+    public @Nullable ChunkLoader getChunkLoader(@NotNull Dimension dimension)
     {
         File dimDir = saveFormat.getDimensionRootDir(worldDirName, dimension);
         dimDir.mkdirs();
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
index f6915c744..3f8a8fadc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/SaveFormatBase.java
@@ -38,7 +38,7 @@ public abstract class SaveFormatBase
     {
         CompoundTag tag = getLevelDataRaw(worldDirName);
         if (tag == null) return null;
-        return new LevelData(tag);
+        return LevelData.fromCompoundTag(tag);
     }
 
     @Override
@@ -81,15 +81,15 @@ public abstract class SaveFormatBase
     }
 
     @Override
-    public DimensionData getDimensionData(String worldDirName, int dimensionId)
+    public DimensionData getDimensionData(@NotNull String worldDirName, @NotNull Dimension dimension)
     {
-        CompoundTag tag = getDimensionDataRaw(worldDirName, dimensionId);
+        CompoundTag tag = getDimensionDataRaw(worldDirName, dimension);
         if (tag == null) return null;
-        return new DimensionData(tag);
+        return DimensionData.fromCompoundTag(tag, dimension);
     }
 
     @Override
-    public CompoundTag getDimensionDataRaw(String worldDirName, int dimensionId)
+    public CompoundTag getDimensionDataRaw(@NotNull String worldDirName, @NotNull Dimension dimension)
     {
         File worldDir = new File(savesDir, worldDirName);
         if(!worldDir.exists())
@@ -97,7 +97,7 @@ public abstract class SaveFormatBase
             return null;
         }
         File dimensionsDir = new File(worldDir, "dimensions");
-        File dimensionDir = new File(dimensionsDir, "" + dimensionId);
+        File dimensionDir = new File(dimensionsDir, "" + dimension.id);
         File dimensionDat = new File(dimensionDir, "dimension.dat");
         if (dimensionDat.exists())
         {
@@ -109,7 +109,7 @@ public abstract class SaveFormatBase
             }
             catch (Exception ex)
             {
-                LOGGER.error("Exception loading dimension dat '{}' for world '{}'!", dimensionId, worldDirName, ex);
+                LOGGER.error("Exception loading dimension dat '{}' for world '{}'!", dimension, worldDirName, ex);
             }
         }
         dimensionDat = new File(dimensionDir, "dimension.dat_old");
@@ -123,7 +123,7 @@ public abstract class SaveFormatBase
             }
             catch (Exception ex)
             {
-                LOGGER.error("Exception loading dimension dat old '{}' for world '{}'!", dimensionId, worldDirName, ex);
+                LOGGER.error("Exception loading dimension dat old '{}' for world '{}'!", dimension, worldDirName, ex);
             }
         }
 
@@ -167,7 +167,7 @@ public abstract class SaveFormatBase
                     }
                     for (Dimension dimension : Dimension.getDimensionList().values())
                     {
-                        dimensionData.put(dimension.id, getDimensionData(worldDirName, dimension.id));
+                        dimensionData.put(dimension.id, getDimensionData(worldDirName, dimension));
                     }
                 }
                 saveFileList.add(new SaveFile(worldDirName, worldName, levelData, dimensionData, lastTimePlayed, size, needsConversion));
diff --git a/game/core/src/main/java/net/minecraft/core/world/season/SeasonManager.java b/game/core/src/main/java/net/minecraft/core/world/season/SeasonManager.java
index 1dbf08351..df8473bbc 100644
--- a/game/core/src/main/java/net/minecraft/core/world/season/SeasonManager.java
+++ b/game/core/src/main/java/net/minecraft/core/world/season/SeasonManager.java
@@ -5,6 +5,8 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.config.season.SeasonConfig;
 import net.minecraft.core.world.config.season.SeasonConfigCycle;
 import net.minecraft.core.world.config.season.SeasonConfigSingle;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
 
@@ -13,7 +15,7 @@ import java.util.List;
  */
 public abstract class SeasonManager
 {
-    public static SeasonManager fromConfig(World world, SeasonConfig config)
+    public static @NotNull SeasonManager fromConfig(@NotNull World world, @NotNull SeasonConfig config)
     {
         if (config instanceof SeasonConfigSingle)
         {
@@ -23,10 +25,8 @@ public abstract class SeasonManager
         {
             return new SeasonManagerCycle(world, (SeasonConfigCycle) config);
         }
-        else
-        {
-            return null;
-        }
+
+        throw new IllegalArgumentException("Invalid season config!");
     }
 
     /**
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
index 5dba29a81..d45ea3c07 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -85,7 +85,7 @@ public abstract class WorldType {
         return brightnessRamp;
     }
 
-    public SeasonConfig getSeasonConfig() {
+    public @NotNull SeasonConfig getSeasonConfig() {
         return seasonConfig;
     }
 
@@ -141,7 +141,7 @@ public abstract class WorldType {
         return (double)y / (double)range;
     }
 
-    public abstract BiomeProvider createBiomeProvider(World world);
+    public abstract @NotNull BiomeProvider createBiomeProvider(World world);
 
     public abstract @NotNull Biome @NotNull [] allBiomes();
 
@@ -180,7 +180,7 @@ public abstract class WorldType {
                 attemptsRemaining--;
             }
             if (found) {
-                world.getLevelData().setSpawn(spawnPos.x, spawnPos.y, spawnPos.z);
+                world.getLevelData().getSpawnPos().set(spawnPos);
                 return;
             }
         }
@@ -203,24 +203,23 @@ public abstract class WorldType {
             }
             attemptsRemaining--;
         }
-        world.getLevelData().setSpawn(spawnPos.x, spawnPos.y, spawnPos.z);
+        world.getLevelData().getSpawnPos().set(spawnPos);
     }
 
     public void getRespawnLocation(World world) {
         LevelData levelData = world.getLevelData();
-        if(levelData.getSpawnY() <= 0) {
-            levelData.setSpawnY(getOceanY());
+        if(levelData.getSpawnPos().y() <= 0) {
+            levelData.getSpawnPos().y = getOceanY();
         }
-        int x = levelData.getSpawnX();
-        int z = levelData.getSpawnZ();
+        int x = levelData.getSpawnPos().x();
+        final int y = levelData.getSpawnPos().y();
+        int z = levelData.getSpawnPos().z();
         while (world.getTopBlock(x, z) == 0) {
             x += world.rand.nextInt(8) - world.rand.nextInt(8);
             z += world.rand.nextInt(8) - world.rand.nextInt(8);
         }
 
-        levelData.setSpawnX(x);
-        levelData.setSpawnZ(z);
-
+        levelData.getSpawnPos().set(x, y, z);
     }
 
     protected int getDayLengthTicks(World world) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
index f367fd9b8..d2abd3115 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeDebug.java
@@ -25,7 +25,7 @@ public class WorldTypeDebug
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
     }
 
@@ -46,7 +46,7 @@ public class WorldTypeDebug
 
     @Override
     public void getInitialSpawnLocation(World world, @Nullable Biome startingBiome) {
-        world.getLevelData().setSpawn(0, 1, 0);
+        world.getLevelData().getSpawnPos().set(0, 1, 0);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
index 8c4fedf23..208d5afb3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypeEmpty.java
@@ -30,7 +30,7 @@ public class WorldTypeEmpty
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
     }
 
@@ -51,7 +51,7 @@ public class WorldTypeEmpty
 
     @Override
     public void getInitialSpawnLocation(World world, @Nullable Biome startingBiome) {
-        world.getLevelData().setSpawn(0, 1, 0);
+        world.getLevelData().getSpawnPos().set(0, 1, 0);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java b/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java
index c1e850d2f..322629de5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/drift/WorldTypeDrift.java
@@ -53,7 +53,7 @@ public class WorldTypeDrift
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.DRIFT_DRIFT, 0.5, 0.0, 0.0);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
index c77053c8d..2090ca074 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
@@ -43,8 +43,7 @@ public class WorldTypeNether
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
-//        return new BiomeProviderSingleBiome(Biomes.NETHER_NETHER, 1.0, 0.0, 1.0);
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderNether(world.getRandomSeed());
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
index 2e98e3b02..7fe2b1d83 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
@@ -17,7 +17,7 @@ public class WorldTypeFlat
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 0.5, 0.0, 0.0);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
index d401efce2..a0291dc1d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
@@ -54,7 +54,7 @@ public class WorldTypeOverworld
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderOverworld(world.getRandomSeed(), this);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java
index 5365694fd..c15c2ebeb 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldB173.java
@@ -15,7 +15,7 @@ public class WorldTypeOverworldB173
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderB173(world.getRandomSeed());
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java
index 6e59dace9..1c75f2e40 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java
@@ -17,7 +17,7 @@ public class WorldTypeOverworldClassic
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
index b3b168cae..2acf4fb1f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
@@ -7,6 +7,7 @@ import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.floating.ChunkGeneratorOverworldFloating;
 import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
 
 public class WorldTypeOverworldFloating
         extends WorldTypeOverworld {
@@ -15,7 +16,7 @@ public class WorldTypeOverworldFloating
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderOverworld(world.getRandomSeed(), this)
                 .withTemperatureScales(0.00625, 0.00625, 0.25, 0.01)
                 .withHumidityScales(0.0125, 0.0125, 0.3, 0.01)
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java
index faf55ee91..20f8898e5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java
@@ -23,7 +23,7 @@ public class WorldTypeOverworldHell
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_HELL, 1.0, 1.0, 0.0);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
index 12451aa1f..8337b9fc9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
@@ -43,7 +43,7 @@ public class WorldTypeOverworldIndev
                 }
             }
         }
-        world.getLevelData().setSpawn(x, y, z);
+        world.getLevelData().getSpawnPos().set(x, y, z);
 
         LevelGenerator.generateHouse(world);
     }
@@ -53,7 +53,7 @@ public class WorldTypeOverworldIndev
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java
index e91e9ba7b..af2d80f60 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldRetro.java
@@ -16,7 +16,7 @@ public class WorldTypeOverworldRetro
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java
index f78a5c4d0..509afb222 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldSkyblock.java
@@ -17,7 +17,7 @@ public class WorldTypeOverworldSkyblock
     }
 
     @Override
-    public BiomeProvider createBiomeProvider(World world) {
+    public @NotNull BiomeProvider createBiomeProvider(World world) {
         return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 1.0, 1.0, 1.0);
     }
 
@@ -38,7 +38,7 @@ public class WorldTypeOverworldSkyblock
 
     @Override
     public void getInitialSpawnLocation(World world, @Nullable Biome startingBiome) {
-        world.getLevelData().setSpawn(0, 66, 0);
+        world.getLevelData().getSpawnPos().set(0, 66, 0);
     }
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index 81f0ab46d..a49350ddf 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -70,8 +70,8 @@ import net.minecraft.core.util.helper.RestHandler;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
-import net.minecraft.core.world.chunk.IChunkLoader;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.save.ISaveConverter;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.world.save.LevelData;
@@ -107,6 +107,7 @@ import net.minecraft.server.world.ConvertProgressUpdater;
 import net.minecraft.server.world.WorldManager;
 import net.minecraft.server.world.WorldServer;
 import net.minecraft.server.world.chunk.provider.ChunkProviderServer;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
@@ -471,7 +472,7 @@ public class MinecraftServer
 
         try
         {
-            LevelData info = new LevelData(new File(worldDirName));
+            LevelData info = LevelData.fromWorldDir(new File(worldDirName));
             worldSaveVersion = info.getSaveVersion();
         }
         catch (IOException e)
@@ -525,25 +526,24 @@ public class MinecraftServer
 
     }
 
-    private void initWorld(ISaveFormat saveFormat, String worldDirName, long l)
+    private void initWorld(ISaveFormat saveFormat, String worldDirName, long seed)
     {
         convertWorld(saveFormat, worldDirName);
         dimensionWorlds = new Int2ObjectArrayMap<>();
-        LevelStorageServer saveHandler = new LevelStorageServer(saveFormat, new File("."), worldDirName, true);
-        for (Int2ObjectMap.Entry<Dimension> entry : Dimension.getDimensionList().int2ObjectEntrySet())
+        LevelStorageServer levelStorage = new LevelStorageServer(saveFormat, new File("."), worldDirName, true);
+        for (final @NotNull Dimension dimension : Dimension.getDimensionList().values())
         {
-            int dimId = entry.getIntKey();
             WorldServer worldServer;
-            if (dimId == 0)
+            if (dimension.id == 0)
             {
-                worldServer = new WorldServer(this, saveHandler, worldDirName, dimId, l);
+                worldServer = new WorldServer(this, levelStorage, worldDirName, seed, dimension);
             }
             else
             {
-                worldServer = new WorldServer(this, dimensionWorlds.get(0), dimId);
+                worldServer = new WorldServer(dimensionWorlds.get(0), dimension);
             }
-            dimensionWorlds.put(dimId, worldServer);
-            worldServer.addListener(new WorldManager(this, dimensionWorlds.get(dimId)));
+            dimensionWorlds.put(dimension.id, worldServer);
+            worldServer.addListener(new WorldManager(this, dimensionWorlds.get(dimension.id)));
             worldServer.setDifficulty(difficulty, true);
             worldServer.sleepPercent = sleepPercentage;
             worldServer.getSpawnerConfig().setHostileSpawning(spawnHostiles);
@@ -587,7 +587,7 @@ public class MinecraftServer
                         outputPercentRemaining("Preparing spawn area", (k1 * 100) / j1);
                         l1 = l2;
                     }
-                    worldServer.chunkProviderServer.prepareChunk(chunkcoordinates.x + k >> 4, chunkcoordinates.z + i1 >> 4);
+                    worldServer.getChunkProvider().prepareChunk(chunkcoordinates.x + k >> 4, chunkcoordinates.z + i1 >> 4);
                     while (worldServer.updatingLighting() && serverRunning) ;
                 }
 
@@ -930,12 +930,6 @@ public class MinecraftServer
     }
 
 
-    @Override
-    public IChunkProvider createChunkProvider(World world, IChunkLoader chunkLoader)
-    {
-        return new ChunkProviderServer((WorldServer)world, chunkLoader, world.worldType.createChunkGenerator(world));
-    }
-
     @Override
     public void logInfo(String s) {
         LOGGER.info(s);
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index 7410b9e8e..b031a1053 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -63,7 +63,7 @@ public class PlayerServer extends Player implements ContainerListener {
         int i = chunkcoordinates.x;
         int j = chunkcoordinates.z;
         int k = chunkcoordinates.y;
-        if (!world.worldType.hasCeiling())
+        if (!world.getWorldType().hasCeiling())
         {
             i += random.nextInt(20) - 10;
             k = world.findTopSolidBlock(i, j);
diff --git a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
index 1c6416ea0..3aa4cc3d6 100644
--- a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -119,7 +119,7 @@ public class PlayerList
         }
         getPlayerManager(player.dimension).addPlayer(player);
         WorldServer world = server.getDimensionWorld(player.dimension);
-        world.chunkProviderServer.prepareChunk((int) player.x >> 4, (int) player.z >> 4);
+        world.getChunkProvider().prepareChunk((int) player.x >> 4, (int) player.z >> 4);
     }
 
     public int getMaxTrackingDistance()
@@ -142,7 +142,7 @@ public class PlayerList
         playerEntities.add(player);
         player.playerNetServerHandler.handleSendInitialPlayerList();
         WorldServer world = server.getDimensionWorld(player.dimension);
-        world.chunkProviderServer.prepareChunk((int) player.x >> 4, (int) player.z >> 4);
+        world.getChunkProvider().prepareChunk((int) player.x >> 4, (int) player.z >> 4);
 
         if (!world.getWorldType().hasCeiling())
         {
@@ -237,11 +237,11 @@ public class PlayerList
                 newPlayer.playerNetServerHandler.sendPacket(new PacketBedMessage(0));
             }
         }
-        worldserver.chunkProviderServer.prepareChunk((int) newPlayer.x >> 4, (int) newPlayer.z >> 4);
+        worldserver.getChunkProvider().prepareChunk((int) newPlayer.x >> 4, (int) newPlayer.z >> 4);
         while (!worldserver.getCubes(newPlayer, newPlayer.bb).isEmpty()) {
             newPlayer.setPos(newPlayer.x, newPlayer.y + 1.0D, newPlayer.z);
         }
-        newPlayer.playerNetServerHandler.sendPacket(new PacketRespawn((byte) newPlayer.dimension, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(worldserver.worldType)));
+        newPlayer.playerNetServerHandler.sendPacket(new PacketRespawn((byte) newPlayer.dimension, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(worldserver.getWorldType())));
         server.playerList.sendPacketToAllPlayers(new PacketPlayerGamemode(newPlayer.id, newPlayer.gamemode.getId()));
         newPlayer.playerNetServerHandler.teleportAndRotate(newPlayer.x, newPlayer.y, newPlayer.z, newPlayer.yRot, newPlayer.xRot);
         setTime(newPlayer, worldserver);
@@ -261,7 +261,7 @@ public class PlayerList
 
         playerServer.dimension = targetDim;
         WorldServer worldserver1 = server.getDimensionWorld(playerServer.dimension);
-        playerServer.playerNetServerHandler.sendPacket(new PacketRespawn((byte) playerServer.dimension, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(worldserver1.worldType)));
+        playerServer.playerNetServerHandler.sendPacket(new PacketRespawn((byte) playerServer.dimension, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(worldserver1.getWorldType())));
         worldserver.removePlayer(playerServer);
         playerServer.removed = false;
         double x = playerServer.x;
@@ -293,9 +293,9 @@ public class PlayerList
             playerServer.teleport(x, playerServer.y, z, playerServer.yRot, playerServer.xRot);
             worldserver1.updateEntityWithOptionalForce(playerServer, false);
             if (generatePortal){
-                worldserver1.chunkProviderServer.chunkLoadOverride = true;
+                worldserver1.getChunkProvider().chunkLoadOverride = true;
                 (new PortalHandler()).teleportEntity(worldserver1, playerServer, portalColor, lastDim, newDim);
-                worldserver1.chunkProviderServer.chunkLoadOverride = false;
+                worldserver1.getChunkProvider().chunkLoadOverride = false;
             }
         }
         syncPlayerDimension(playerServer);
